require 'Sketchup'
def doComponent
  colPoints = [ 
    Geom::Point3d.new(0, 0, -2),
    Geom::Point3d.new(10, 0, -2),
    Geom::Point3d.new(10, 10, -2),
    Geom::Point3d.new(0, 10, -2) ]
  
  newFace = Sketchup.active_model.entities.add_face(colPoints[0], colPoints[1], colPoints[2], colPoints[3])
  
  newFace.pushpull(8, false)
  newGroupEntities = newFace.all_connected
  
  newGroupEntities.each do |theEntity|
    if theEntity.kind_of?(Sketchup::Face)
      if theEntity.normal == newFace.normal or theEntity.normal == newFace.normal.reverse
        theEntity.material = 0x948B4E
        theEntity.material.alpha = 0.1
      else
        theEntity.material = 0xBDDEE1;
      end
    end
  end
  
  newGroup = Sketchup.active_model.entities.add_group(newGroupEntities.to_a)
  
  #add entities for the cut plane
  colPoints.each do |thePoint|
    thePoint.z = 2
  end  
  Sketchup.active_model.entities.add_line(colPoints[0], colPoints[1])
  Sketchup.active_model.entities.add_line(colPoints[1], colPoints[2])
  Sketchup.active_model.entities.add_line(colPoints[2], colPoints[3])
  Sketchup.active_model.entities.add_line(colPoints[3], colPoints[0])

  #create the component  
  newGroup = Sketchup.active_model.entities.add_group(Sketchup.active_model.entities.to_a)
  newComponent = newGroup.to_component
  newComponent.definition.name = "My Component"
  newDefinition = Sketchup.active_model.definitions[newComponent.definition.name]
  
  #transform the component's axes so the cut plane entities and the xy axes coincide
  transformation = Geom::Transformation.translation(Geom::Vector3d.new(0, 0, -4))
  newDefinition.entities.transform_entities(transformation, newComponent.definition.entities.to_a)
  
  #set the component behavior to glue to ("snap to") vertical surfaces and cut an opening
  newDefinition.behavior.snapto = SnapTo_Vertical
  newDefinition.behavior.cuts_opening = true
  
  puts "newDefinition.behavior.snapto=" + newDefinition.behavior.snapto.to_s
end

doComponent